/* $Id: General.c 354 2004-07-17 06:28:14Z cher $ */

/* Copyright (C) 1995-2004 Alexander Chernov <cher@ispras.ru> */
/* Ich, Doktor Josef Grosch, Informatiker, Sept. 1987 */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

/* reuse include directives */
#include <reuse/Defs.h>
#include <reuse/General.h>

/* Returns the logarithm to the base 2 of 'x'.  */
Cardinal
Log2(unsigned long x)
{
  register Cardinal y = 0;

  if (x >= 65536) { y += 16; x >>= 16; }
  if (x >=   256) { y +=  8; x >>=  8; }
  if (x >=    16) { y +=  4; x >>=  4; }
  if (x >=     4) { y +=  2; x >>=  2; }
  if (x >=     2) { y +=  1; x >>=  1; }
  return y;
}

/* Returns 2 to the power of 'x'.               */
unsigned long
Exp2(Cardinal x)
{
  register long y = 1;
  
  if (x >= 16) { x -= 16; y <<= 16; }
  if (x >=  8) { x -=  8; y <<=  8; }
  if (x >=  4) { x -=  4; y <<=  4; }
  if (x >=  2) { x -=  2; y <<=  2; }
  if (x >=  1) { x -=  1; y <<=  1; }
  return y;
}

static struct { char yychar; double yydouble; } yyForAlign;
unsigned short   yyMaxAlign      = sizeof (yyForAlign) - sizeof (double);
long    yyAlignMasks [] = { 0,
   0xffffffff, 0xfffffffe, 0xffffffff, 0xfffffffc,
   0xffffffff, 0xffffffff, 0xffffffff, 0xfffffff8 };

  unsigned short
ReuseGetMaxAlign(void)
{
  return yyMaxAlign;
}

  long*
ReuseGetAlignMasks(void)
{
  return yyAlignMasks;
}

#if REUSE_COMPILE_CVSID - 0 != 0
static char const rcsid [] =
"$Id: General.c 354 2004-07-17 06:28:14Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make"
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE" "Cardinal")
 * End:
 */
