/* $Id: alloca_impl.h 353 2004-07-17 06:26:07Z cher $ */

#ifndef __REUSE_ALLOCA_IMPL_H__
#define __REUSE_ALLOCA_IMPL_H__

/* Copyright (C) 2004 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#ifndef __GNUC__
# if HAVE_ALLOCA_H
#  include <alloca.h>
#  define do_alloca(z) alloca(z)
# else /* no HAVE_ALLOCA_H */
#  if HAVE_ALLOCA
#   define do_alloca(z) alloca(z)
#  elif HAVE__ALLOCA
#   define do_alloca(z) _alloca(z)
#  else /* no alloca and _alloca */
#   ifdef _AIX
#    pragma alloca
#    define do_alloca(z) alloca(z)
#   else /* not on AIX */
#    ifndef alloca
char *alloca();
#     define do_alloca(z) alloca(z)
#    else
#     define do_alloca(z) alloca(z)
#    endif
#   endif
#  endif
# endif
#else /* __GNUC__ */
# define do_alloca(z) alloca(z)
#endif

#endif /* __REUSE_ALLOCA_IMPL_H__ */
