/* $Id: System.c 57 2001-06-23 07:04:26Z cher $ */

/* Copyright (C) 2000-2001 Alexander Chernov <cher@ispras.ru> */
/* Created: <2000-07-01 19:44:57 cher> */

/*
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

/* See the header file System.h for comments concerning the external
   routines!    */

static char const cvsid[] = 
"$Id: System.c 57 2001-06-23 07:04:26Z cher $";

#include "lconfig.h"
#include <p_config.h>

#include CONF_DEPFILE("reuse_version.h")

#include "reuse/Defs.h"
#include "reuse/System.h"
#include "reuse/xalloc.h"
#include "reuse/logger.h"

#include <errno.h>

#include <unistd.h>
#include <fcntl.h>
#include <time.h>
#include <sys/stat.h>

  Bool
IsCharacterSpecial(tFile File)
{
  struct stat  buf;

  (void) fstat (File, & buf);
  return S_ISCHR(buf.st_mode);
}

  tFile
OpenInput(char const *FileName)
{
  return open(FileName, O_RDONLY | O_BINARY);
}

  tFile
OpenOutput(char const *FileName)
{
  return creat(FileName, S_IWUSR);
}

  int
Read(tFile File, char *Buffer, int Size)
{
  return read(File, Buffer, Size);
}

  int
Write (tFile File, char *Buffer, int Size)
{
  return write(File, Buffer, Size);
}

  void
Close (tFile File)
{
  (void) close(File);
}

  char *
SysAlloc(long ByteCount)
{
  return (char *) xmalloc ((unsigned) ByteCount);
}

  long
Time()
{
  return clock () * 1000 / CLOCKS_PER_SEC;
}

static int      argc;
static char * * argv;

  int
GetArgCount()
{
  return argc;
}

  void
GetArgument(int ArgNum, char *Argument)
{
  register int i = 0;
  for (;; i ++)
    if ((Argument [i] = argv [ArgNum][i]) == '\0')
      return;
}

  void
PutArgs(int Argc, char **Argv)
{
  argc = Argc;
  argv = Argv;
}

  int
ErrNum()
{ 
  return errno;
}

  int
System(char const *String)
{ 
  return system(String);
}

  void
Exit(int Status)
{ 
  exit(Status);
}

  void
BEGIN_System()
{
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("FILE" "\\sw+_t" "tFile" "Bool")
 * End:
 */
