/* -*- mode:c -*- */
/* $Id: hash2.c 354 2004-07-17 06:28:14Z cher $ */

/* Copyright (C) 2002-2004 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

/* reuse include directives */
#include <reuse/hash.h>
#include <reuse/FlexString.h>

ident_t
ident_read_from_file(FILE *f)
{
  fsRead(reuse_fsTempBuf, f);
  return ident_put(fsString(reuse_fsTempBuf), fsLength(reuse_fsTempBuf));
}

ident_t
ident_get_from_file(FILE *f)
{
  fsGet(reuse_fsTempBuf, f);
  return ident_put(fsString(reuse_fsTempBuf), fsLength(reuse_fsTempBuf));
}

#if REUSE_COMPILE_CVSID - 0 != 0
static const unsigned char cvsid[] __attribute__((unused)) =
"$Id: hash2.c 354 2004-07-17 06:28:14Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make"
 * End:
 */
