/* -*- mode:c -*- */
/* $Id: ident_dump_table.c 354 2004-07-17 06:28:14Z cher $ */

/* Copyright (C) 2002-2004 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

/* reuse include directives */
#include <reuse/hashP.h>

extern hashstate_t ident_state;

/**
 * NAME:    ident_dump_table
 * PURPOSE: print the whole identifier table
 * ARGS:    out - FILE to print the table to
 */
void
ident_dump_table(FILE *out)
{
  int i;

  if (!ident_state.initialized) ident_init();

  fprintf(out, "Identifier table\n");
  fprintf(out, "================\n");
  fprintf(out, "Num\tMap\tIndex\tHash\t\tLen\tString\n");
  for (i = 0; i < ident_state.total_idents; i++)
    {
      fprintf(out, "%d\t%d\t%d\t%08x\t%d\t%s\n",
              i,
              ident_state.map[i],
              ident_state.table[ident_state.map[i]].hash % ident_state.table_size,
              ident_state.table[ident_state.map[i]].hash,
              ident_state.table[ident_state.map[i]].len,
              ident_state.table[ident_state.map[i]].string);
    }
}

#if REUSE_COMPILE_CVSID - 0 != 0
static const unsigned char cvsid[] __attribute__((unused)) =
"$Id: ident_dump_table.c 354 2004-07-17 06:28:14Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make"
 * End:
 */
