/* -*- mode:c -*- */
/* $Id: ident_reinit.c 354 2004-07-17 06:28:14Z cher $ */

/* Copyright (C) 2002-2004 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

/* reuse include directives */
#include <reuse/hashP.h>
#include <reuse/xalloc.h>

extern hashstate_t ident_state;

/**
 * NAME:    ident_reinit
 * PURPOSE: reset the existing hash table
 */
void
ident_reinit(void)
{
  int i;

  if (!ident_state.initialized) ident_init();

  ident_state.total_idents = 1;
  for (i = 1; i < ident_state.table_size; i++)
    {
      if (ident_state.table[i].hash != 0)
        {
          ident_state.table[i].hash = 0;
          ident_state.table[i].ident = 0;
          xfree(ident_state.table[i].string);
          ident_state.table[i].string = NULL;
          ident_state.table[i].len = 0;
        }
    }
}

#if REUSE_COMPILE_CVSID - 0 != 0
static const unsigned char cvsid[] __attribute__((unused)) =
"$Id: ident_reinit.c 354 2004-07-17 06:28:14Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make"
 * End:
 */
