/* -*- mode:c -*- */
/* $Id: ident_statistics.c 354 2004-07-17 06:28:14Z cher $ */

/* Copyright (C) 2002-2004 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

/* reuse include directives */
#include <reuse/hashP.h>

extern hashstate_t ident_state;

/**
 * NAME:    ident_statistics
 * PURPOSE: print usage statistics
 * ARGS:    out - FILE to print statistics to
 */
void
ident_statistics(FILE *out)
{
  if (!ident_state.initialized) ident_init();

  fprintf(out, "Identifier table statistics:\n");
  fprintf(out, "============================\n");
  fprintf(out, "Table size:              %d\n", ident_state.table_size);
  fprintf(out, "Number of identifiers:   %d\n", ident_state.total_idents);
  fprintf(out, "Capacity percentage:     %f%%\n",
          ((double) ident_state.total_idents / (double) ident_state.table_size)*100);
  fprintf(out, "Number of rehashings:    %d\n", ident_state.stat_rehash_num);
  fprintf(out, "Number of lookups:       %d\n", ident_state.stat_lookups_num);
  fprintf(out, "Number of successes:     %d\n", ident_state.stat_success_num);
  fprintf(out, "Number of search cycles: %d\n", ident_state.stat_cycles_num);
  fprintf(out, "Average search length:   %f\n",
          (double) ident_state.stat_cycles_num / (double) ident_state.stat_lookups_num);
}

#if REUSE_COMPILE_CVSID - 0 != 0
static const unsigned char cvsid[] __attribute__((unused)) =
"$Id: ident_statistics.c 354 2004-07-17 06:28:14Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make"
 * End:
 */
