/* $Id: Defs.h 57 2001-06-23 07:04:26Z cher $ */

#ifndef __DEFS_H__
#define __DEFS_H__

/* Copyright (C) 1995-2001 Alexander Chernov <cher@ispras.ru> */
/* Ich, Doktor Josef Grosch, Informatiker, Sept. 1987 */
/* Alexander Chernov, November 1995 */

/*
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#if !defined(Bool)

#define Bool  int
#define False 0
#define True  1

#endif
/* This is RASTA-wide boolean type. Use of this type recommended
 * instead of plain 0 or 1 values.
 */

typedef unsigned short Cardinal;

#ifndef bool
#define bool      char
#endif

#ifndef true
#define true      1
#endif

#ifndef false
#define false     0
#endif
/* This is Cocktail native boolean type. Declarations of this
 * constants are automatically generated by certain Cocktail
 * tools (such as PUMA and AST, etc.).
 */

/* This typedef is used in Cocktail generated modules. Most heavily
 * it is used in AST trees since AST requires to attribute type to be
 * a single name. This type is used where standard C null-terminated
 * string type required.
 */
typedef char * tString;

/* typedef to pass in source position line. */
typedef unsigned int line_t;

#endif /* __DEFS_H__ */

