/* $Id: DynArray.h 352 2004-07-17 06:11:56Z cher $ */

#ifndef __REUSE_DYNARRAY_h__
#define __REUSE_DYNARRAY_h__

/* Copyright (C) 1995-2004 Alexander Chernov <cher@ispras.ru> */
/* Ich, Doktor Josef Grosch, Informatiker, Sept. 1987 */
/* Alexander Chernov, December 1995 */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include <stdio.h>

#include <reuse/ReuseDefs.h>

#if defined __cplusplus
extern "C" {
#endif /* __cplusplus */

  R_DLL void dynInitModule (void);
  R_DLL void dynCloseModule(void);
  R_DLL void dynStatistics (FILE *);

  R_DLL void MakeArray (char **p, unsigned long *c, unsigned long s);
/* 'p' is set to the start address of a  */
/* memory space to hold an array of 'c' */
/* elements each of size 's' bytes.      */

  R_DLL void ExtendArray(char **p, unsigned long *c, unsigned long s);
/* The memory space for the array is increased  */
/* by doubling the number of elements.          */

  R_DLL void ReleaseArray(char **p, unsigned long *c, unsigned long s);
/* The memory space for the array is released.  */

#if defined __cplusplus
}
#endif /* __cplusplus */

# endif /* __REUSE_DYNARRAY_H__ */

/*
 * Local variables:
 *  compile-command: "make -C ../.."
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE" "R_DLL")
 * End:
 */
