/* $Id: General.h 300 2002-06-15 22:00:00Z cher $ */

#ifndef __REUSE_GENERAL_H__
#define __REUSE_GENERAL_H__

/* Copyright (C) 1995-2002 Alexander Chernov <cher@ispras.ru> */
/* Ich, Doktor Josef Grosch, Informatiker, Sept. 1987 */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#ifdef __cplusplus
extern "C" {
#endif

#include <reuse/Defs.h>
#include <reuse/ReuseDefs.h>

#define Min(a,b) ((a <= b) ? a : b)
                        /* Returns the minimum of 'a' and 'b'.          */
#define Max(a,b) ((a >= b) ? a : b)
                        /* Returns the maximum of 'a' and 'b'.          */

extern R_DLL Cardinal         Log2(unsigned long x);
                        /* Returns the logarithm to the base 2 of 'x'.  */
extern R_DLL unsigned long    Exp2(Cardinal x);
                        /* Returns 2 to the power of 'x'.               */

extern R_DLL unsigned short  ReuseGetMaxAlign(void);
extern R_DLL long           *ReuseGetAlignMasks(void);

#if defined __REUSE__
extern unsigned short    yyMaxAlign;
extern long     yyAlignMasks [];
#else
#define yyMaxAlign   (ReuseGetMaxAlign())
#define yyAlignMasks (ReuseGetAlignMasks())
#endif /* __REUSE__ */

#ifdef __cplusplus
};
#endif

#endif /* __REUSE_GENERAL_H__ */

/**
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("FILE" "\\sw+_t" "Bool" "Cardinal" "R_DLL")
 * End:
 */
