/* $Id: MemPage.h 352 2004-07-17 06:11:56Z cher $ */

#ifndef __REUSE_MEMPAGE_H__
#define __REUSE_MEMPAGE_H__

/* Copyright (C) 1995-2004 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include <reuse/ReuseDefs.h>

#include <stdio.h>
#include <stdlib.h>

struct tPageBlock;
struct tPageDesc;
typedef struct tPageDesc tPageDesc;

#if defined __cplusplus
extern "C" {
#endif /* __cplusplus */

  R_DLL void pgInitModule(void);
  R_DLL void pgCloseModule(void);
  R_DLL void pgStatistics(FILE *);

  R_DLL tPageDesc *pgCreate(size_t Size);
  R_DLL void       pgDestroy(tPageDesc *);
  R_DLL void      *pgMalloc(tPageDesc *,size_t);
  R_DLL void      *pgCalloc(tPageDesc *, size_t nelem, size_t elem_size);
  R_DLL void       pgPageStatistics(tPageDesc *, FILE *);    

#if defined __cplusplus
}
#endif /* __cplusplus */

#endif /* __MEMPAGE_H__ */

/**
 * Local variables:
 *  compile-command: "make -C ../.."
 *  c-font-lock-extra-types: ("tIdent" "FILE" "\\sw+_t" "Bool" "tPageDesc" "R_DLL")
 * End:
 */

