/* $Id: Memory.h 300 2002-06-15 22:00:00Z cher $ */

#ifndef __REUSE_MEMORY_H__
#define __REUSE_MEMORY_H__

/* Copyright (C) 1999-2002 Alexander Chernov */
/* Ich, Doktor Josef Grosch, Informatiker, Sept. 1987 */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include <reuse/ReuseDefs.h>

#ifdef __cplusplus
extern "C" {
#endif

/*extern unsigned long MemoryUsed ;*/
                        /* Holds the total amount of memory managed by  */
                        /* this module.                                 */

extern R_DLL void     InitMemory(void);
                        /* The memory module is initialized.            */

extern R_DLL char *   Alloc(unsigned long ByteCount);
                        /* Returns a pointer to dynamically allocated   */
                        /* space of size 'ByteCount' bytes.             */

extern R_DLL void     Free(unsigned long ByteCount, char * a);
                        /* The dynamically allocated space starting at  */
                        /* address 'a' of size 'ByteCount' bytes is     */
                        /* released.                                    */

#ifdef __cplusplus
};
#endif

#endif /* __REUSE_MEMORY_H__ */

/**
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("FILE" "\\sw+_t" "R_DLL")
 * End:
 */
