/* $Id: Source.h 305 2002-06-15 22:18:12Z cher $ */

#ifndef __REUSE_SOURCE_H__
#define __REUSE_SOURCE_H__

/* Copyright (C) 1995-2002 Alexander Chernov <cher@ispras.ru> */
/* Ich, Doktor Josef Grosch, Informatiker, Juli 1992 */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include <reuse/ReuseDefs.h>

#ifdef __cplusplus
extern "C" {
#endif

extern R_DLL int  BeginSource(char * FileName);

   /*
      BeginSource is called from the scanner to open files.
      If not called input is read form standard input.
   */

extern R_DLL int  GetLine(int File, char * Buffer, int Size);

   /*
      GetLine is called to fill a buffer starting at address 'Buffer'
      with a block of maximal 'Size' characters. Lines are terminated
      by newline characters (ASCII = 0xa). GetLine returns the number
      of characters transferred. Reasonable block sizes are between 128
      and 2048 or the length of a line. Smaller block sizes -
      especially block size 1 - will drastically slow down the scanner.
   */

extern R_DLL void CloseSource(int File);

   /*
      CloseSource is called from the scanner at end of file respectively
      at end of input. It can be used to close files.
   */

#ifdef __cplusplus
};
#endif

#endif /* __REUSE_SOURCE_H__ */

/**
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("FILE" "\\sw+_t" "R_DLL")
 * End:
 */
