/* $Id: errors.h 315 2003-08-01 19:55:42Z cher $ */

#ifndef __REUSE_ERRORS_H__
#define __REUSE_ERRORS_H__

/* Copyright (C) 1997-2003 Alexander Chernov <cher@ispras.ru> */
/* Created: Fri Jul 11 20:17:26 1997 by cher (Alexander Chernov) */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

/* Error classes */
enum
{
  ERC_NONE = 0,                 /* not used */
  ERC_INFO = 1,
  ERC_NOTICE,
  ERC_WARNING,
  ERC_ERROR,
  ERC_SEVERE,
  ERC_CRIT,
  ERC_FATAL
};

/* this structure is reuse-compatible (for now) */
typedef struct tErrorTable
{
  int   Number;
  int   Class;
  char *Format;
} tErrorTable, *ptErrorTable;

struct tPosition;

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

R_DLL void err_Initialize(void);
R_DLL int  err_Register(const tErrorTable * const);

R_DLL int  err_Write(int, ...);
R_DLL int  err_vWrite(/*int code, va_list args*/);
R_DLL int  err_sWrite(int, char *, ...);
R_DLL int  err_vsWrite(/*int severity, char *format, va_list args*/);
R_DLL int  err_psWrite(int, struct tPosition *, char *, ...);
R_DLL int  err_vpsWrite(/*int sev, tPosition *pos, char *f, va_list args*/);
R_DLL int  err_pWrite(int, struct tPosition *, ...);
R_DLL int  err_vpWrite(/*int code, tPosition *pos, va_list args*/);

typedef int (*err_tfWriteHandler)(/*
                                   *void              *data,
                                   *int               sev,
                                   *int               code,
                                   *struct tPosition *pos,
                                   *char             *sev_str,
                                   *char             *pos_str,
                                   *char             *format,
                                   *va_list           args
                                   */);

R_DLL err_tfWriteHandler err_InstallWriteHandler(err_tfWriteHandler, void*);

R_DLL void err_ClearCntr(void);
R_DLL int  err_GetCntr(int);
R_DLL int  err_GetSumCntr(int);

R_DLL void *err_SaveCounters(void);
R_DLL void  err_RestoreCounters(void *);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __REUSE_ERRORS_H__ */

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("FILE" "\\sw+_t" "tErrorTable" "err_tfWriteHandler" "va_list" "R_DLL")
 * End:
 */
