/* -*- mode: c -*- */
/* $Id: format_io.h 306 2002-06-15 22:20:21Z cher $ */

#ifndef __REUSE_FORMAT_IO_H__
#define __REUSE_FORMAT_IO_H__

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include <reuse/ReuseDefs.h>

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

#ifdef __GNUC__

R_DLL int os_printf(char const *, ...)
       __attribute__ ((format (printf, 1, 2)));
R_DLL int os_fprintf(FILE *, char const *, ...)
       __attribute__ ((format (printf, 2, 3)));
R_DLL int os_sprintf(char *, char const *, ...)
       __attribute__ ((format (printf, 2, 3)));
R_DLL int os_snprintf(char *, size_t, char const *, ...)
       __attribute__ ((format (printf, 3, 4)));

R_DLL int os_vprintf(char const *, va_list)
       __attribute__ ((format (printf, 1, 0)));
R_DLL int os_vfprintf(FILE *, char const *, va_list)
       __attribute__ ((format (printf, 2, 0)));
R_DLL int os_vsprintf(char *, char const *, va_list)
       __attribute__ ((format (printf, 2, 0)));
R_DLL int os_vsnprintf(char *, size_t, char const *, va_list)
       __attribute__ ((format (printf, 3, 0)));

R_DLL int os_scanf(char const *, ...)
       __attribute__ ((format (scanf, 1, 2)));
R_DLL int os_fscanf(FILE *, char const *, ...)
       __attribute__ ((format (scanf, 2, 3)));
R_DLL int os_sscanf(char const *, char const *, ...)
       __attribute__ ((format (scanf, 2, 3)));

R_DLL int os_vscanf(char const *, va_list)
       __attribute__ ((format (scanf, 1, 0)));
R_DLL int os_vfscanf(FILE *, char const *, va_list)
       __attribute__ ((format (scanf, 2, 0)));
R_DLL int os_vsscanf(char const *, char const *, va_list)
       __attribute__ ((format (scanf, 2, 0)));

#else

R_DLL int os_printf(char const *, ...);
R_DLL int os_fprintf(FILE *, char const *, ...);
R_DLL int os_sprintf(char *, char const *, ...);
R_DLL int os_snprintf(char *, size_t, char const *, ...);

R_DLL int os_vprintf(char const *, va_list);
R_DLL int os_vfprintf(FILE *, char const *, va_list);
R_DLL int os_vsprintf(char *, char const *, va_list);
R_DLL int os_vsnprintf(char *, size_t, char const *, va_list);

R_DLL int os_scanf(char const *, ...);
R_DLL int os_fscanf(FILE *, char const *, ...);
R_DLL int os_sscanf(char const *, char const *, ...);

R_DLL int os_vscanf(char const *, va_list);
R_DLL int os_vfscanf(FILE *, char const *, va_list);
R_DLL int os_vsscanf(char const *, char const *, va_list);

#endif

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __REUSE_FORMAT_IO_H__ */

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE" "va_list" "R_DLL")
 * End:
 */
