/* -*- mode: c -*- */
/* $Id: format_io_int.h 306 2002-06-15 22:20:21Z cher $ */

#ifndef __REUSE_FORMAT_IO_INT_H__
#define __REUSE_FORMAT_IO_INT_H__

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include <reuse/ReuseDefs.h>
#include <reuse/format_io.h>

struct reuse_scanf_funcs
{
  int (*next_char)(void*);
  int (*prev_char)(void *, int);
};

R_DLL int _reuse_vscanf(struct reuse_scanf_funcs *, void *, char const *, va_list);

struct reuse_printf_funcs
{
  int (*put_char)(void *, int);
  int (*put_string)(void *, char const *);
  int (*put_mem)(void *, char const *, size_t);
};

R_DLL int _reuse_vprintf(struct reuse_printf_funcs *, void *, char const *, va_list);

#endif /* __REUSE_FORMAT_IO_INT_H__ */
/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE" "va_list" "R_DLL")
 * End:
 */
