/* -*- mode: c -*- */
/* $Id: fp_props.h 306 2002-06-15 22:20:21Z cher $ */

#ifndef __REUSE_FP_PROPS_H__
#define __REUSE_FP_PROPS_H__

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include <reuse/ReuseDefs.h>

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

R_DLL void reuse_set_zero_ld(int, long double *);
R_DLL void reuse_set_infinity_ld(int, long double *);
R_DLL void reuse_set_nan_ld(long double *);
R_DLL int reuse_get_sign_bit_ld(const long double *);
R_DLL int reuse_is_infinity_ld(const long double *);
R_DLL int reuse_is_nan_ld(const long double *);

R_DLL void reuse_set_zero_f(int, float *);
R_DLL void reuse_set_infinity_f(int, float *);
R_DLL void reuse_set_nan_f(float *);
R_DLL int reuse_get_sign_bit_f(const float *);
R_DLL int reuse_is_infinity_f(const float *);
R_DLL int reuse_is_nan_f(const float *);

R_DLL void reuse_set_zero_d(int, double *);
R_DLL void reuse_set_infinity_d(int, double *);
R_DLL void reuse_set_nan_d(double *);
R_DLL int reuse_get_sign_bit_d(const double *);
R_DLL int reuse_is_infinity_d(const double *);
R_DLL int reuse_is_nan_d(const double *);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __REUSE_FP_PROPS_H__ */

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE" "va_list" "R_DLL")
 * End:
 */
