/* $Id: hash.h 315 2003-08-01 19:55:42Z cher $ */

#ifndef __REUSE_HASH_H__
#define __REUSE_HASH_H__

/* Copyright (C) 1996-2002 Alexander Chernov <cher@ispras.ru> */
/* Created: Fri Nov  1 18:44:54 1996 by cher (Alexander Chernov) */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include <reuse/ReuseDefs.h>

#include <stdio.h>

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

typedef unsigned long ident_t;
typedef unsigned int hash_t;

R_DLL void     ident_init(void);
R_DLL void     ident_reinit(void);
R_DLL void     ident_close(void);
R_DLL void     ident_statistics(FILE *f);
R_DLL void     ident_dump_table(FILE *f);
R_DLL ident_t  ident_put(char const *, int);
R_DLL char    *ident_get(ident_t);
R_DLL char    *ident_dup(ident_t);
R_DLL hash_t   ident_hash(char const *, int);

enum { ident_empty = 0 };

R_DLL ident_t ident_read_from_file(FILE *);
R_DLL ident_t ident_get_from_file(FILE *);

/* For AST tree writers */
#define writeident_t(i)       fsWriteStr(ident_get(i),yyf);
#define readident_t(i)        i = ident_read_from_file(yyf);
#define putident_t(i)         fsPutStr(ident_get(i), yyf);
#define getident_t(i)         i = ident_get_from_file(yyf);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __REUSE_HASH_H__ */

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE" "va_list" "R_DLL")
 * End:
 */
