/* $Id: lists.h 315 2003-08-01 19:55:42Z cher $ */

#ifndef __REUSE_LISTS_H__
#define __REUSE_LISTS_H__

/* Copyright (C) 1998-2003 Alexander Chernov <cher@ispras.ru> */
/* Created: <1998-03-17 18:03:12 cher> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include <reuse/ReuseDefs.h>

/* Generic list entry */
typedef struct tGenListEntry
{
  struct tGenListEntry *prev;
  struct tGenListEntry *next;
  /* data comes here */
} tGenListEntry, *tpGenListEntry;

/* generic list structure */
typedef struct tGenList
{
  struct tGenListEntry *first;
  struct tGenListEntry *last;
  /* data comes here */
} tGenList, *tpGenList;

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

R_DLL void *list_Find(/*list, num*/);
R_DLL void  list_Insert(/*list, num, entry*/);
R_DLL void *list_Remove(/*list, num*/);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __REUSE_LISTS_H__ */

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE" "va_list" "R_DLL")
 * End:
 */
