/* $Id: osdeps.h 406 2005-10-27 08:58:39Z cher $ */

#ifndef __REUSE_OSDEPS_H__
#define __REUSE_OSDEPS_H__

/* Copyright (C) 1997-2005 Alexander Chernov <cher@ispras.ru> */
/* Created: <1997-11-18 16:14:11 cher> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include <reuse/ReuseDefs.h>

/**
 * FILE:    utils/osdeps.h
 * PURPOSE: miscellanious os-dependent functions
 */

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

R_DLL char *os_GetErrorString(int);
R_DLL char *os_GetSignalString(int);
R_DLL char *os_ErrorString(void);
R_DLL char *os_ErrorMsg(void);

R_DLL char *os_FindInPath(char const *);

R_DLL char *os_GetSuffix(char const *);
R_DLL int   os_rGetSuffix(char const *, char *, int);
R_DLL char *os_SubstSuffix(char const *, char const *);

R_DLL char *os_GetBasename(char const *);
R_DLL int   os_rGetBasename(char const *, char *, int);
R_DLL char *os_GetLastname(char const *);
R_DLL int   os_rGetLastname(char const *, char *, int);

R_DLL int   os_MakeDirPath(char const *, int);
R_DLL int   os_MakeDir(char const *, int);

R_DLL char *os_DirName(char const *);
R_DLL int   os_rDirName(char const *, char *, int);
R_DLL char *os_NodeName(void);
R_DLL char *os_tempnam(char const *, char const *);

enum { OSPK_REG = 0, OSPK_DIR = 1, OSPK_OTHER = 2 };
R_DLL int   os_IsFile(char const *path);

R_DLL char *get_PRJ_HOME(void);
R_DLL char *get_PRJ_HOME_name(void);
R_DLL char *get_PRJ_CONFIG(void);
R_DLL char *get_PRJ_CONFIG_name(void);
R_DLL int   os_GuessProjectEnv(char *, char const *);

R_DLL int os_SetLock(char const *, int, int);

enum { REUSE_X_OK = 1, REUSE_W_OK = 2, REUSE_R_OK = 4, REUSE_F_OK = 8 };
R_DLL int os_CheckAccess(char const *path, int perms);
R_DLL void *os_AttachFILE(int, char const *);

R_DLL void os_Sleep(int);

R_DLL char *os_GetWorkingDir(void);
R_DLL int   os_rGetWorkingDir(char *, unsigned int, int);
R_DLL int   os_IsAbsolutePath(char const *);
R_DLL void  os_normalize_path(char *);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __REUSE_OSDEPS_H__ */

/*
 * Local variables:
 *  compile-command: "make -C ../.."
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE" "va_list" "R_DLL")
 * End:
 */
