/* $Id: pprintf.h 57 2001-06-23 07:04:26Z cher $ */

#ifndef __PPRINTF_H__
#define __PPRINTF_H__

/* Copyright (C) 1998-2001 Alexander Chernov <cher@ispras.ru> */

/*
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#ifdef __GNUC__
#define GNUC_ATTR(a,b) __attribute__ ((format(printf, a, b)))
#else
#define GNUC_ATTR(a,b)
#endif /* __GNUC__ */

#if defined __cplusplus
extern "C" {
#endif /* __cplusplus */

  int   reuse_snprintf  (char *, int, char const *, ...) GNUC_ATTR(3, 4);
  int   reuse_format_len(char const *, ...)              GNUC_ATTR(1, 2);
  char *ssprintf        (char const *, ...)              GNUC_ATTR(1, 2);

  int   reuse_vsnprintf();
  int   reuse_vformat_len();
  char *vssprintf();

#if defined __cplusplus
}
#endif /* __cplusplus */

#undef GNUC_ATTR

#endif /* __PPRINTF_H__ */

/*
 * Local variables:
 *  compile-command: "make -C .."
 * End:
 */
