/* -*- mode:c -*- */
/* $Id: os_readint.c 354 2004-07-17 06:28:14Z cher $ */

/* Copyright (C) 2002-2004 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

/* reuse include directives */
#include <reuse/integral.h>
#include <reuse/number_io.h>

#include <errno.h>
#include <stdlib.h>

/**
 * NAME:    os_readint
 * PURPOSE: read int value from the string
 * ARGS:    str - string to read from
 *          val - pointer to the location to store read value
 * RETURN:  <0 - error, 0 - ok
 */
int
os_readint(char const *str, int *val)
{
  char *s;
  int t;

  errno = 0;
  t = strtol(str, &s, 10);
  if (*s != 0) return -1;
  if (errno != 0) return -errno;
  *val = t;
  return 0;
}

#if REUSE_COMPILE_CVSID - 0 != 0
static char const rcsid [] =
"$Id: os_readint.c 354 2004-07-17 06:28:14Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make"
 * End:
 */
