/* -*- mode:c -*- */
/* $Id: os_readll.c 354 2004-07-17 06:28:14Z cher $ */

/* Copyright (C) 2002-2004 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

/* reuse include directives */
#include <reuse/integral.h>
#include <reuse/number_io.h>

#include <errno.h>

#if R_HAS_INT64 - 0 == 1
extern rllong_t reuse_strtoll(char const *, char **, int);
#endif /* R_HAS_INT64 */

int
os_readll(char const *str, char **endptr, int base, void *pvval)
{
  rllong_t *pval = (rllong_t*) pvval;
  rllong_t  val;
  int       ecode;
  char     *s;

  errno = 0;
  val = reuse_strtoll(str, &s, base);
  ecode = errno;
  errno = 0;
  if (endptr == (char**) 1 && *s) ecode = 1;
  if (endptr && endptr != (char**) 1) *endptr = s;
  *pval = val;
  return -ecode;
}

#if REUSE_COMPILE_CVSID - 0 != 0
static char const rcsid [] =
"$Id: os_readll.c 354 2004-07-17 06:28:14Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make"
 * End:
 */
