/* -*- mode:c -*- */
/* $Id: poscmp.c 354 2004-07-17 06:28:14Z cher $ */

/* Copyright (C) 2002-2004 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

/* reuse include directives */
#include <reuse/PositionsP.h>

extern posstate_t positions_state;
#define S positions_state

int
posCmp(const tPosition *pos1,const tPosition *pos2)
{
  if(pos1->FName  < pos2->FName)  return -1;
  if(pos1->FName  > pos2->FName)  return 1;
  if(pos1->Line   < pos2->Line)   return -1;
  if(pos1->Line   > pos2->Line)   return 1;
  if(pos1->Column < pos2->Column) return -1;
  if(pos1->Column > pos2->Column) return 1;
  return 0;
}

#if REUSE_COMPILE_CVSID - 0 != 0
static char const rcsid [] =
"$Id: poscmp.c 354 2004-07-17 06:28:14Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make"
 *  c-font-lock-extra-types: ("FILE" "\\sw+_t" "Bool" "tssDesc" "tPosition" "tssEntry")
 * End:
 */
