/* -*- mode:c -*- */
/* $Id: set_assign.c 354 2004-07-17 06:28:14Z cher $ */

/* Copyright (C) 2002-2004 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

/* reuse include directives */
#include <reuse/integral.h>
#include <reuse/bitset.h>
#include <reuse/logger.h>

#include <string.h>

void
set_assign(bitset_t *pdst, bitset_t const *psrc)
{
  ASSERT(pdst);
  ASSERT(psrc);
  ASSERT(pdst->size == psrc->size);

  if (pdst == psrc) return;
  memcpy(pdst->bits, psrc->bits, psrc->arr_size * sizeof(pdst->bits[0]));
  pdst->card = psrc->card;
  pdst->first = psrc->first;
  pdst->last = psrc->last;
}

#if REUSE_COMPILE_CVSID - 0 != 0
static char const rcsid [] =
"$Id: set_assign.c 354 2004-07-17 06:28:14Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make"
 * End:
 */

