/* -*- mode:c -*- */
/* $Id: set_init.c 354 2004-07-17 06:28:14Z cher $ */

/* Copyright (C) 2002-2004 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

/* reuse include directives */
#include <reuse/integral.h>
#include <reuse/bitset.h>
#include <reuse/xalloc.h>
#include <reuse/logger.h>

#include <string.h>

void
set_init(bitset_t *pset, unsigned int size)
{
  ASSERT(pset);
  ASSERT(size > 0);

  XMEMZERO(pset, 1);

  pset->size = size;
  pset->arr_size = (pset->size + BITSET_BPW) >> BITSET_BPS;
  XCALLOC(pset->bits, pset->arr_size);
  pset->card = 0;
  pset->first = -1;
  pset->last = -1;
}

#if REUSE_COMPILE_CVSID - 0 != 0
static char const rcsid [] =
"$Id: set_init.c 354 2004-07-17 06:28:14Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make"
 * End:
 */

