/* -*- mode:c -*- */
/* $Id: ssdput.c 354 2004-07-17 06:28:14Z cher $ */

/* Copyright (C) 2002-2004 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

/* reuse include directives */
#include <reuse/StringSet.h>
#include <reuse/FlexString.h>

#include <assert.h>
#include <stdlib.h>

#define CLUSTER            16

#ifdef REUSE_DEBUG
#define CHECKSSD(ssd) \
assert((ssd) != NULL && (ssd)->Table != NULL && (ssd)->Allocd >= (ssd)->Used)
#define CHECK(ptr)     assert(ptr != NULL)
#define CHECKSS(tss,pssd)  assert(tss < (pssd)->Used)
#else
#define CHECKSSD(s)
#define CHECK(ptr)
#define CHECKSS(tss,pssd)
#endif

  void
_ssdPut(tssDesc *pssd,FILE *f)
{
  int i;

  CHECKSSD(pssd);
  CHECK(f);

  fwrite(&pssd->Used,sizeof(pssd->Used),1,f);
  for(i=1;(unsigned int) i < pssd->Used;i++)
    {
      fsPutStr(pssd->Table[i],f);
    }

  if (pssd->Transl != NULL)
    free(pssd->Transl);

  pssd->Transl = NULL;
  pssd->TranslSize = 0;
}

#if REUSE_COMPILE_CVSID - 0 != 0
static char const rcsid [] =
"$Id: ssdput.c 354 2004-07-17 06:28:14Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make"
 *  c-font-lock-extra-types: ("FILE" "\\sw+_t" "tssDesc" "tssEntry" "tFString" "Bool")
 * End:
 */
