/* -*- mode: C -*- */
/* $Id: strnlen.c 354 2004-07-17 06:28:14Z cher $ */

/* Copyright (C) 2002-2004 Alexander Chernov <cher@ispras.ru> */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

#if CONF_HAS_STRNLEN - 0 == 1 && defined __linux__ && !defined _GNU_SOURCE
#define _GNU_SOURCE 1
#endif

/* reuse include directives */
#include <reuse/integral.h>
#include <reuse/str_utils.h>

#include <string.h>

size_t
reuse_strnlen(char const *str, size_t maxlen)
{
#if CONF_HAS_STRNLEN - 0 == 1
  return strnlen(str, maxlen);
#else
  size_t ind = 0;

  while (str[ind] && ind < maxlen) ind++;
  return ind;
#endif /* strnlen is present */
}

#if REUSE_COMPILE_CVSID - 0 != 0
static char const rcsid [] =
"$Id: strnlen.c 354 2004-07-17 06:28:14Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make"
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE")
 * End:
 */
