/* $Id: System.c 346 2004-07-10 18:46:02Z cher $ */

/* Copyright (C) 1995-2004 Alexander Chernov <cher@ispras.ru> */
/* Ich, Doktor Josef Grosch, Informatiker, Jan. 1992 */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

/* See the header file System.h for comments concerning the external
   routines!    */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

/* reuse include directives */
#include <reuse/Defs.h>
#include <reuse/System.h>
#include <reuse/xalloc.h>

#include <stdlib.h>
#include <errno.h>
#include <time.h>
#include <sys/times.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

  Bool
IsCharacterSpecial(tFile File)
{
  struct stat  buf;

  (void) fstat (File, & buf);
  return S_ISCHR(buf.st_mode);
}

  tFile
OpenInput(char const *FileName)
{
  return open(FileName, O_RDONLY);
}

  tFile
OpenOutput(char const *FileName)
{
  return creat(FileName, 0666);
}

  int
Read(tFile File, char *Buffer, int Size)
{
  return read(File, Buffer, Size);
}

  int
Write (tFile File, char *Buffer, int Size)
{
  return write(File, Buffer, Size);
}

  void
Close (tFile File)
{
  (void) close(File);
}

  char *
SysAlloc(long ByteCount)
{
  return (char *) xmalloc ((unsigned) ByteCount);
}

  long
Time()
{
  return clock () * 1000 / CLOCKS_PER_SEC;
}

static int      argc;
static char * * argv;

  int
GetArgCount()
{
  return argc;
}

  void
GetArgument(int ArgNum, char *Argument)
{
  register int i = 0;
  for (;; i ++)
    if ((Argument [i] = argv [ArgNum][i]) == '\0')
      return;
}

  void
PutArgs(int Argc, char **Argv)
{
  argc = Argc;
  argv = Argv;
}

  int
ErrNum()
{ 
  return errno;
}

  int
System(char const *String)
{ 
  return system(String);
}

  void
Exit(int Status)
{ 
  exit(Status);
}

  void
BEGIN_System()
{
}

#if REUSE_COMPILE_CVSID - 0 != 0
static char const cvsid[] = 
"$Id: System.c 346 2004-07-10 18:46:02Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("FILE" "\\sw+_t" "tFile" "Bool")
 * End:
 */
