/* -*- mode:c -*- */
/* $Id: os_checkaccess.c 347 2004-07-10 18:47:03Z cher $ */

/* Copyright (C) 2002-2004 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

/* reuse include directives */
#include <reuse/osdeps.h>

#include <unistd.h>
#include <errno.h>

  int
os_CheckAccess(char const *path, int perms)
{
  int r_perms = 0;
  int res     = 0;

  if ((perms & REUSE_X_OK)) r_perms |= X_OK;
  if ((perms & REUSE_W_OK)) r_perms |= W_OK;
  if ((perms & REUSE_R_OK)) r_perms |= R_OK;
  if ((perms & REUSE_F_OK)) r_perms |= F_OK;

  errno = 0;
  res = access(path, r_perms);
  return (res >= 0)?res:-errno;
}

#if REUSE_COMPILE_CVSID - 0 != 0
static char const rcsid [] =
"$Id: os_checkaccess.c 347 2004-07-10 18:47:03Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make -C .."
 * End:
 */
