/* $Id: System.c 369 2004-09-11 06:13:25Z cher $ */

/* Copyright (C) 1999-2004 Alexander Chernov <cher@ispras.ru> */
/* Created: <1999-07-20 11:48:08 cher> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

/* reuse include directives */
#include <reuse/System.h>
#include <reuse/logger.h>
#include <reuse/xalloc.h>

#include <stdio.h>

  char *
SysAlloc(long ByteCount)
{
  return (char*) xmalloc(ByteCount);
}

  void
Exit(int Status)
{
  exit(Status);
}

struct file_arr
{
  int    a, u;
  FILE **v;
};
static struct file_arr files;

static int initialized = 0;
  static void
init_files(void)
{
  if (initialized) return;
  initialized = 1;

  XEXPAND2(files);
  files.v[files.u++] = stdin;
  XEXPAND2(files);
  files.v[files.u++] = stdout;
  XEXPAND2(files);
  files.v[files.u++] = stderr;
}

  tFile
OpenInput(char const *FileName)
{
  FILE *f;
  int   idx;

  init_files();
  f = fopen(FileName, "rb");
  if (!f) return -1;

  for (idx = 0; idx < files.u && files.v[idx]; idx++);
  if (idx >= files.u) {
    XEXPAND2(files);
    idx = files.u++;
  }

  files.v[idx] = f;
  return idx;
}

  int
Read(tFile file, char *Buffer, int Size)
{
  init_files();
  return fread(Buffer, 1, Size, files.v[file]);
}

  void
Close(tFile File)
{
  init_files();
  fclose(files.v[File]);
}

  long
Time(void)
{
  SWERR(("Time: not supported"));
}

#if REUSE_COMPILE_CVSID - 0 != 0
static char const cvsid[]=
"$Id: System.c 369 2004-09-11 06:13:25Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("FILE" "\\sw+_t" "tFile")
 * End:
 */
