/* -*- mode:c -*- */
/* $Id: os_getsignalstring.c 369 2004-09-11 06:13:25Z cher $ */

/* Copyright (C) 2002-2004 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#define __REUSE__ 1

/* internal include directives */
#include "lconfig.h"
#include "reuse/config.h"
#include "embed_version.h"

/* reuse include directives */
#include <reuse/osdeps.h>
#include <reuse/format_io.h>

/**
 * NAME:    os_GetSignalString
 * PURPOSE: get the signal name
 * ARGS:    s - signal number
 * RETURN:  string with the signal name
 */
char *
os_GetSignalString(int s)
{
  static char buf[64];

  switch (s) {
  case 5:
    return "Access violation";
  case 256:
    return "Software abort";
  }
  os_snprintf(buf, sizeof(buf), "Signal %d", s);
  return buf;
}

#if REUSE_COMPILE_CVSID - 0 != 0
static char const rcsid [] =
"$Id: os_getsignalstring.c 369 2004-09-11 06:13:25Z cher $";
#endif /* REUSE_COMPILE_CVSID */

/*
 * Local variables:
 *  compile-command: "make -C ../.."
 * End:
 */
